diff --git a/gcc/ada/checks.ads b/gcc/ada/checks.ads
index 322629a3c1f..83d3fdb8329 100644
--- a/gcc/ada/checks.ads
+++ b/gcc/ada/checks.ads
@@ -49,8 +49,8 @@ package Checks is
       record
          Elements : Bit_Vector (1 .. Dimensions);
       end record;
-   Empty_Dimension_Set : constant Dimension_Set
-     := (Dimensions => 0, Elements => (others => <>));
+   Empty_Dimension_Set : constant Dimension_Set :=
+     (Dimensions => 0, Elements => (others => <>));
 
    procedure Initialize;
    --  Called for each new main source program, to initialize internal
diff --git a/gcc/ada/cstand.adb b/gcc/ada/cstand.adb
index 6b45d252163..d2e4a6b0c82 100644
--- a/gcc/ada/cstand.adb
+++ b/gcc/ada/cstand.adb
@@ -1334,8 +1334,8 @@ package body CStand is
       --  used internally. They are unsigned types with the same length as
       --  the correspondingly named signed integer types.
 
-      Standard_Short_Short_Unsigned
-        := New_Standard_Entity ("short_short_unsigned");
+      Standard_Short_Short_Unsigned :=
+        New_Standard_Entity ("short_short_unsigned");
       Build_Unsigned_Integer_Type
         (Standard_Short_Short_Unsigned, Standard_Short_Short_Integer_Size);
 
diff --git a/gcc/ada/exp_aggr.adb b/gcc/ada/exp_aggr.adb
index aa6079d82b5..83b88e7cf73 100644
--- a/gcc/ada/exp_aggr.adb
+++ b/gcc/ada/exp_aggr.adb
@@ -7126,9 +7126,9 @@ package body Exp_Aggr is
 
       --  Determine whether this is an indexed aggregate (see RM 4.3.5(25/5))
 
-      Is_Indexed_Aggregate
-        := Sem_Aggr.Is_Indexed_Aggregate
-             (N, Add_Unnamed_Subp, New_Indexed_Subp);
+      Is_Indexed_Aggregate :=
+        Sem_Aggr.Is_Indexed_Aggregate
+          (N, Add_Unnamed_Subp, New_Indexed_Subp);
 
       --  The constructor for bounded containers is a function with
       --  a parameter that sets the size of the container. If the
@@ -7140,8 +7140,8 @@ package body Exp_Aggr is
       declare
          Count_Type         : Entity_Id := Standard_Natural;
          Default            : Node_Id   := Empty;
-         Empty_First_Formal : constant Entity_Id
-                                := First_Formal (Entity (Empty_Subp));
+         Empty_First_Formal : constant Entity_Id :=
+           First_Formal (Entity (Empty_Subp));
          Param_List         : List_Id;
 
       begin
@@ -7636,8 +7636,8 @@ package body Exp_Aggr is
 
                declare
                   --  recursively get name for prefix
-                  LHS_Prefix : constant Node_Id
-                    := Make_Delta_Choice_LHS (Prefix (Choice), Deep_Choice);
+                  LHS_Prefix : constant Node_Id :=
+                    Make_Delta_Choice_LHS (Prefix (Choice), Deep_Choice);
                begin
                   if Nkind (Choice) = N_Indexed_Component then
                      return Make_Indexed_Component (Sloc (Choice),
diff --git a/gcc/ada/exp_ch4.adb b/gcc/ada/exp_ch4.adb
index 106305f4636..9024c1aebb2 100644
--- a/gcc/ada/exp_ch4.adb
+++ b/gcc/ada/exp_ch4.adb
@@ -2799,9 +2799,9 @@ package body Exp_Ch4 is
 
                if Is_Constrained (Opnd_Typ) then
                   declare
-                     Low_Bound : constant Node_Id
-                       := Type_Low_Bound
-                            (Underlying_Type (Etype (First_Index (Opnd_Typ))));
+                     Low_Bound : constant Node_Id :=
+                       Type_Low_Bound
+                         (Underlying_Type (Etype (First_Index (Opnd_Typ))));
 
                   begin
                      if Compile_Time_Known_Value (Low_Bound) then
@@ -3013,11 +3013,11 @@ package body Exp_Ch4 is
                else
                   declare
                      Known_Bound : constant Node_Id := Get_Known_Bound (J + 1);
-                     Comparison  : constant Compare_Result
-                                     := Compile_Time_Compare
-                                          (Opnd_Low_Bound (J),
-                                           Known_Bound,
-                                           Assume_Valid => True);
+                     Comparison  : constant Compare_Result :=
+                       Compile_Time_Compare
+                         (Opnd_Low_Bound (J),
+                          Known_Bound,
+                          Assume_Valid => True);
 
                   begin
                      if Comparison = EQ then
diff --git a/gcc/ada/exp_ch5.adb b/gcc/ada/exp_ch5.adb
index 7ff54cb2c40..8cad734628a 100644
--- a/gcc/ada/exp_ch5.adb
+++ b/gcc/ada/exp_ch5.adb
@@ -2969,9 +2969,9 @@ package body Exp_Ch5 is
       then
          Tagged_Case : declare
             L                   : List_Id := No_List;
-            Expand_Ctrl_Actions : constant Boolean
-                                    := not No_Ctrl_Actions (N)
-                                         and then not No_Finalize_Actions (N);
+            Expand_Ctrl_Actions : constant Boolean :=
+              not No_Ctrl_Actions (N)
+                and then not No_Finalize_Actions (N);
 
          begin
             --  In the controlled case, we ensure that function calls are
@@ -3791,8 +3791,8 @@ package body Exp_Ch5 is
                      pragma Assert (No (Expressions (Pattern)));
 
                      declare
-                        Component_Assoc : Node_Id
-                          := First (Component_Associations (Pattern));
+                        Component_Assoc : Node_Id :=
+                          First (Component_Associations (Pattern));
                         Choice : Node_Id;
 
                         function Subobject return Node_Id is
diff --git a/gcc/ada/exp_dbug.adb b/gcc/ada/exp_dbug.adb
index 64e3871ef82..9ab2203f6f9 100644
--- a/gcc/ada/exp_dbug.adb
+++ b/gcc/ada/exp_dbug.adb
@@ -1061,8 +1061,8 @@ package body Exp_Dbug is
       if Ancestor_Typ /= Typ then
          declare
             Len      : constant Natural := Name_Len;
-            Save_Str : constant String (1 .. Name_Len)
-                         := Name_Buffer (1 .. Name_Len);
+            Save_Str : constant String (1 .. Name_Len) :=
+              Name_Buffer (1 .. Name_Len);
          begin
             Get_External_Name (Ancestor_Typ);
 
diff --git a/gcc/ada/exp_util.adb b/gcc/ada/exp_util.adb
index 756638c52c2..8e5cdb7332e 100644
--- a/gcc/ada/exp_util.adb
+++ b/gcc/ada/exp_util.adb
@@ -8700,12 +8700,12 @@ package body Exp_Util is
                     and then Nkind (Selector_Name (Param)) = N_Identifier
                   then
                      declare
-                        Actual : constant Node_Id
-                          := Explicit_Actual_Parameter (Param);
-                        Formal : constant Node_Id
-                          := Selector_Name (Param);
-                        Name   : constant String
-                          := Get_Name_String (Chars (Formal));
+                        Actual : constant Node_Id :=
+                          Explicit_Actual_Parameter (Param);
+                        Formal : constant Node_Id :=
+                          Selector_Name (Param);
+                        Name   : constant String :=
+                          Get_Name_String (Chars (Formal));
 
                      begin
                         --  A nonnull BIPaccess has been found
@@ -10335,8 +10335,8 @@ package body Exp_Util is
       pragma Assert (Has_Invariants (Typ));
       Proc_Id  : constant Entity_Id := Invariant_Procedure (Typ);
       pragma Assert (Present (Proc_Id));
-      Inv_Typ  : constant Entity_Id
-                   := Base_Type (Etype (First_Formal (Proc_Id)));
+      Inv_Typ  : constant Entity_Id :=
+        Base_Type (Etype (First_Formal (Proc_Id)));
 
       Arg : Node_Id;
 
@@ -11580,8 +11580,8 @@ package body Exp_Util is
 
       if All_Extensions_Allowed then
          declare
-            Rep : constant Node_Id
-              := Get_Rep_Item (Typ, Name_Finalizable, Check_Parents => True);
+            Rep : constant Node_Id :=
+              Get_Rep_Item (Typ, Name_Finalizable, Check_Parents => True);
 
             Assoc : Node_Id;
 
@@ -12724,11 +12724,11 @@ package body Exp_Util is
                   --  was called).
 
                   if Is_Array_Type (Exp_Type) then
-                     Scope_Suppress.Suppress (Length_Check)
-                       := Svg_Suppress.Suppress (Length_Check);
+                     Scope_Suppress.Suppress (Length_Check) :=
+                       Svg_Suppress.Suppress (Length_Check);
                   else
-                     Scope_Suppress.Suppress (Discriminant_Check)
-                       := Svg_Suppress.Suppress (Discriminant_Check);
+                     Scope_Suppress.Suppress (Discriminant_Check) :=
+                       Svg_Suppress.Suppress (Discriminant_Check);
                   end if;
 
                   E := Make_Qualified_Expression (Loc,
diff --git a/gcc/ada/gnatlink.adb b/gcc/ada/gnatlink.adb
index db0fd144a13..e2cd1968064 100644
--- a/gcc/ada/gnatlink.adb
+++ b/gcc/ada/gnatlink.adb
@@ -1259,8 +1259,10 @@ procedure Gnatlink is
                                 Value (Libgcc_Subdir_Ptr);
 
                            begin
-                              Path (GCC_Index + 1 .. GCC_Index + Subdir'Length)
-                                := Subdir;
+                              Path
+                                (GCC_Index + 1
+                                 ..
+                                 GCC_Index + Subdir'Length) := Subdir;
                               GCC_Index := GCC_Index + Subdir'Length;
                            end;
                         end if;
diff --git a/gcc/ada/lib-util.adb b/gcc/ada/lib-util.adb
index 3f0b4631e60..6bf9d7bc482 100644
--- a/gcc/ada/lib-util.adb
+++ b/gcc/ada/lib-util.adb
@@ -271,8 +271,7 @@ package body Lib.Util is
 
    procedure Write_Info_Str (Val : String) is
    begin
-      Info_Buffer (Info_Buffer_Len + 1 .. Info_Buffer_Len + Val'Length)
-                                                                  := Val;
+      Info_Buffer (Info_Buffer_Len + 1 .. Info_Buffer_Len + Val'Length) := Val;
       Info_Buffer_Len := Info_Buffer_Len + Val'Length;
       Info_Buffer_Col := Info_Buffer_Col + Val'Length;
    end Write_Info_Str;
diff --git a/gcc/ada/libgnat/a-except.adb b/gcc/ada/libgnat/a-except.adb
index fef79f62dad..8dafe933ff6 100644
--- a/gcc/ada/libgnat/a-except.adb
+++ b/gcc/ada/libgnat/a-except.adb
@@ -1768,8 +1768,8 @@ package body Ada.Exceptions is
          Exception_Propagation.Propagate_Exception (X);
       else
          declare
-            Excep : constant EOA
-              := Exception_Propagation.Allocate_Occurrence;
+            Excep : constant EOA :=
+              Exception_Propagation.Allocate_Occurrence;
             Saved_MO : constant System.Address := Excep.Machine_Occurrence;
          begin
             Save_Occurrence (Excep.all, X);
diff --git a/gcc/ada/libgnat/a-exexpr.adb b/gcc/ada/libgnat/a-exexpr.adb
index 4ef68c5aa7f..0fe52278a0b 100644
--- a/gcc/ada/libgnat/a-exexpr.adb
+++ b/gcc/ada/libgnat/a-exexpr.adb
@@ -494,8 +494,8 @@ package body Exception_Propagation is
       then
          declare
             Current : constant EOA := Get_Current_Excep.all;
-            Cur_Occ : constant GCC_Exception_Access
-              := To_GCC_Exception (Current.Machine_Occurrence);
+            Cur_Occ : constant GCC_Exception_Access :=
+              To_GCC_Exception (Current.Machine_Occurrence);
          begin
             --  If we are releasing the Machine_Occurrence of the current
             --  exception, reset the access to it, so that it is no
diff --git a/gcc/ada/libgnat/a-ngcoar.adb b/gcc/ada/libgnat/a-ngcoar.adb
index 4c9c0ad2413..6a1028349e8 100644
--- a/gcc/ada/libgnat/a-ngcoar.adb
+++ b/gcc/ada/libgnat/a-ngcoar.adb
@@ -1105,8 +1105,8 @@ package body Ada.Numerics.Generic_Complex_Arrays is
                declare
                   Row : constant Integer := Vectors'First (2) + (K - 1);
                begin
-                  Vectors (Row, Col)
-                     := (Vecs (J * 2, Col), Vecs (J * 2, Col + N));
+                  Vectors (Row, Col) :=
+                    (Vecs (J * 2, Col), Vecs (J * 2, Col + N));
                end;
             end loop;
          end;
diff --git a/gcc/ada/libgnat/s-rannum.adb b/gcc/ada/libgnat/s-rannum.adb
index 2f2fd66c456..14dbc0d8df3 100644
--- a/gcc/ada/libgnat/s-rannum.adb
+++ b/gcc/ada/libgnat/s-rannum.adb
@@ -108,8 +108,8 @@ is
    Lower_Mask : constant := 2**31 - 1;
    Upper_Mask : constant := 2**31;
 
-   Matrix_A   : constant array (State_Val range 0 .. 1) of State_Val
-     := [0, 16#9908b0df#];
+   Matrix_A   : constant array (State_Val range 0 .. 1) of State_Val :=
+     [0, 16#9908b0df#];
    --  The twist transformation is represented by a matrix of the form
    --
    --               [  0    I(31) ]
@@ -280,11 +280,11 @@ is
                    2#01000# => 0, 2#01001# => 1, 2#01010# => 0, 2#01011# => 2,
                    2#01100# => 0, 2#01101# => 1, 2#01110# => 0, 2#01111# => 4];
 
-            Pow_Tab : constant array (Bit_Count range 0 .. 3) of Real
-              := [0 => 2.0**(0 - T'Machine_Mantissa),
-                  1 => 2.0**(-1 - T'Machine_Mantissa),
-                  2 => 2.0**(-2 - T'Machine_Mantissa),
-                  3 => 2.0**(-3 - T'Machine_Mantissa)];
+            Pow_Tab : constant array (Bit_Count range 0 .. 3) of Real :=
+              [0 => 2.0**(0 - T'Machine_Mantissa),
+               1 => 2.0**(-1 - T'Machine_Mantissa),
+               2 => 2.0**(-2 - T'Machine_Mantissa),
+               3 => 2.0**(-3 - T'Machine_Mantissa)];
 
             Extra_Bits : constant Natural :=
                          (Unsigned'Size - T'Machine_Mantissa + 1);
diff --git a/gcc/ada/libgnat/s-trasym__dwarf.adb b/gcc/ada/libgnat/s-trasym__dwarf.adb
index 64ff9a2afea..1b368040728 100644
--- a/gcc/ada/libgnat/s-trasym__dwarf.adb
+++ b/gcc/ada/libgnat/s-trasym__dwarf.adb
@@ -357,16 +357,16 @@ package body System.Traceback.Symbolic is
       --  fail opening that downstream, we'll just bail out.
 
       declare
-         Argv0 : constant System.Address
-           := Conv.To_Pointer (Gnat_Argv) (0);
+         Argv0 : constant System.Address :=
+           Conv.To_Pointer (Gnat_Argv) (0);
 
-         Resolved_Argv0 : constant System.Address
-           := locate_exec_on_path (Argv0);
+         Resolved_Argv0 : constant System.Address :=
+           locate_exec_on_path (Argv0);
 
-         Exe_Argv : constant System.Address
-           := (if Resolved_Argv0 /= System.Null_Address
-               then Resolved_Argv0
-               else Argv0);
+         Exe_Argv : constant System.Address :=
+           (if Resolved_Argv0 /= System.Null_Address
+            then Resolved_Argv0
+            else Argv0);
 
          Result : constant String := Value (Exe_Argv);
 
diff --git a/gcc/ada/osint.adb b/gcc/ada/osint.adb
index 046480b321b..fd70c510fc0 100644
--- a/gcc/ada/osint.adb
+++ b/gcc/ada/osint.adb
@@ -2350,10 +2350,10 @@ package body Osint is
    begin
       --  Construct a C compatible character string buffer
 
-      Buffer (1 .. Search_Dir_Prefix.all'Length)
-        := Search_Dir_Prefix.all;
-      Buffer (Search_Dir_Prefix.all'Length + 1 .. Buffer'Last - 1)
-        := Search_File.all;
+      Buffer (1 .. Search_Dir_Prefix.all'Length) :=
+        Search_Dir_Prefix.all;
+      Buffer (Search_Dir_Prefix.all'Length + 1 .. Buffer'Last - 1) :=
+        Search_File.all;
       Buffer (Buffer'Last) := ASCII.NUL;
 
       File_FD := Open_Read (Buffer'Address, Binary);
diff --git a/gcc/ada/rtsfind.adb b/gcc/ada/rtsfind.adb
index 4cfd9fe4a11..2c1a1ee234b 100644
--- a/gcc/ada/rtsfind.adb
+++ b/gcc/ada/rtsfind.adb
@@ -1187,8 +1187,8 @@ package body Rtsfind is
             else
                Save_Private_Visibility;
                declare
-                  Saved_Instance_Context : constant Instance_Context.Context
-                    := Instance_Context.Save_And_Reset;
+                  Saved_Instance_Context : constant Instance_Context.Context :=
+                    Instance_Context.Save_And_Reset;
                begin
                   Semantics (Cunit (U.Unum));
                   Instance_Context.Restore (Saved_Instance_Context);
diff --git a/gcc/ada/sem_case.adb b/gcc/ada/sem_case.adb
index 267cdaa44c5..9d197870414 100644
--- a/gcc/ada/sem_case.adb
+++ b/gcc/ada/sem_case.adb
@@ -1550,8 +1550,8 @@ package body Sem_Case is
             return Result;
          end Component_Bounds_Info;
 
-         Component_Bounds : constant Composite_Range_Info
-           := Component_Bounds_Info;
+         Component_Bounds : constant Composite_Range_Info :=
+           Component_Bounds_Info;
 
          package Case_Bindings is
 
@@ -2517,8 +2517,8 @@ package body Sem_Case is
 
                use Uint_Sets;
 
-               Result : constant Representative_Values_Array
-                 := (others => Uint_Sets.Create (Initial_Size => 32));
+               Result : constant Representative_Values_Array :=
+                 (others => Uint_Sets.Create (Initial_Size => 32));
 
                procedure Insert_Representative (Value : Uint; P : Part_Id);
                --  Insert the given Value into the representative values set
@@ -2563,8 +2563,8 @@ package body Sem_Case is
                return Result;
             end Representative_Values_Init;
 
-            Representative_Values : constant Representative_Values_Array
-              := Representative_Values_Init;
+            Representative_Values : constant Representative_Values_Array :=
+              Representative_Values_Init;
             --  We want to avoid looking at every point in the Cartesian
             --  product of all component values. Instead we select, for each
             --  component, a set of representative values and then look only
@@ -2664,8 +2664,8 @@ package body Sem_Case is
                   return Equal;
                else
                   declare
-                     Intersection : constant Value_Index_Set
-                       := Indexed (S1) and Indexed (S2);
+                     Intersection : constant Value_Index_Set :=
+                       Indexed (S1) and Indexed (S2);
                   begin
                      if (for all Flag of Intersection => not Flag) then
                         return Disjoint;
diff --git a/gcc/ada/sem_ch12.adb b/gcc/ada/sem_ch12.adb
index 81068d0e6c0..686aa3208fb 100644
--- a/gcc/ada/sem_ch12.adb
+++ b/gcc/ada/sem_ch12.adb
@@ -7736,15 +7736,15 @@ package body Sem_Ch12 is
      (Instance      : Entity_Id;
       Is_Formal_Box : Boolean)
    is
-      Gen_Id : constant Entity_Id
-        := (if Is_Generic_Unit (Instance) then
-              Instance
-            elsif Is_Wrapper_Package (Instance) then
-              Generic_Parent
-                (Specification
-                  (Unit_Declaration_Node (Related_Instance (Instance))))
-            else
-              Generic_Parent (Package_Specification (Instance)));
+      Gen_Id : constant Entity_Id :=
+        (if Is_Generic_Unit (Instance) then
+           Instance
+         elsif Is_Wrapper_Package (Instance) then
+           Generic_Parent
+             (Specification
+               (Unit_Declaration_Node (Related_Instance (Instance))))
+         else
+           Generic_Parent (Package_Specification (Instance)));
       --  The generic unit
 
       Parent_Scope : constant Entity_Id := Scope (Gen_Id);
diff --git a/gcc/ada/sem_ch13.adb b/gcc/ada/sem_ch13.adb
index 3487931bf4d..0546aa37de7 100644
--- a/gcc/ada/sem_ch13.adb
+++ b/gcc/ada/sem_ch13.adb
@@ -13980,8 +13980,8 @@ package body Sem_Ch13 is
         (E   : Entity_Id;
          Nam : Name_Id) return Node_Id
       is
-         Rep : constant Node_Id
-                 := Get_Rep_Item (E, Nam, Check_Parents => True);
+         Rep : constant Node_Id :=
+           Get_Rep_Item (E, Nam, Check_Parents => True);
       begin
          if Present (Rep)
            and then not Has_Rep_Item (E, Nam, Check_Parents => False)
@@ -13997,8 +13997,8 @@ package body Sem_Ch13 is
          Nam1 : Name_Id;
          Nam2 : Name_Id) return Node_Id
       is
-         Rep : constant Node_Id
-                 := Get_Rep_Item (E, Nam1, Nam2, Check_Parents => True);
+         Rep : constant Node_Id :=
+           Get_Rep_Item (E, Nam1, Nam2, Check_Parents => True);
       begin
          if Present (Rep)
            and then not Has_Rep_Item (E, Nam1, Nam2, Check_Parents => False)
@@ -16413,8 +16413,8 @@ package body Sem_Ch13 is
       end if;
 
       declare
-         Set : constant Local_Restriction_Set
-           := Parse_Aspect_Local_Restrictions (Parent (N));
+         Set : constant Local_Restriction_Set :=
+           Parse_Aspect_Local_Restrictions (Parent (N));
          pragma Unreferenced (Set);
       begin
          null;
diff --git a/gcc/ada/sem_ch3.adb b/gcc/ada/sem_ch3.adb
index 2b703dd13c0..3b44f0a5100 100644
--- a/gcc/ada/sem_ch3.adb
+++ b/gcc/ada/sem_ch3.adb
@@ -13153,10 +13153,10 @@ package body Sem_Ch3 is
         and then Present (Underlying_Full_View (Full_Base))
       then
          declare
-            Underlying_Full_Base : constant Entity_Id
-                                           := Underlying_Full_View (Full_Base);
-            Underlying_Full : constant Entity_Id
-                       := Make_Defining_Identifier (Sloc (Priv), Chars (Priv));
+            Underlying_Full_Base : constant Entity_Id :=
+              Underlying_Full_View (Full_Base);
+            Underlying_Full : constant Entity_Id :=
+              Make_Defining_Identifier (Sloc (Priv), Chars (Priv));
          begin
             Set_Is_Itype (Underlying_Full);
             Set_Associated_Node_For_Itype (Underlying_Full, Related_Nod);
diff --git a/gcc/ada/sem_ch6.adb b/gcc/ada/sem_ch6.adb
index fcd15445a07..008c3a7ba13 100644
--- a/gcc/ada/sem_ch6.adb
+++ b/gcc/ada/sem_ch6.adb
@@ -12533,8 +12533,8 @@ package body Sem_Ch6 is
 
                            if Chars (E) = Name_Op_Eq then
                               declare
-                                 Typ : constant Entity_Id
-                                         := Etype (First_Entity (E));
+                                 Typ : constant Entity_Id :=
+                                   Etype (First_Entity (E));
                                  H   : Entity_Id := Homonym (E);
 
                               begin
diff --git a/gcc/ada/sem_eval.adb b/gcc/ada/sem_eval.adb
index 03006b63070..aaf0a766dc3 100644
--- a/gcc/ada/sem_eval.adb
+++ b/gcc/ada/sem_eval.adb
@@ -6185,10 +6185,12 @@ package body Sem_Eval is
 
          if Is_Discrete_Type (T1) and then Is_Discrete_Type (T2) then
             declare
-               Interval_List1 : constant Interval_Lists.Discrete_Interval_List
-                 := Interval_Lists.Type_Intervals (T1);
-               Interval_List2 : constant Interval_Lists.Discrete_Interval_List
-                 := Interval_Lists.Type_Intervals (T2);
+               Interval_List1 :
+                 constant Interval_Lists.Discrete_Interval_List :=
+                 Interval_Lists.Type_Intervals (T1);
+               Interval_List2 :
+                 constant Interval_Lists.Discrete_Interval_List :=
+                 Interval_Lists.Type_Intervals (T2);
             begin
                return Interval_Lists.Is_Subset (Interval_List1, Interval_List2)
                  and then not (Has_Predicates (T1)
diff --git a/gcc/ada/sem_prag.adb b/gcc/ada/sem_prag.adb
index ce18ddca338..87922816a9a 100644
--- a/gcc/ada/sem_prag.adb
+++ b/gcc/ada/sem_prag.adb
@@ -13489,16 +13489,16 @@ package body Sem_Prag is
 
                   when N_Op_Concat =>
                      declare
-                        L_Type : constant Entity_Id
-                          := Preferred_String_Type (Left_Opnd (Expr));
-                        R_Type : constant Entity_Id
-                          := Preferred_String_Type (Right_Opnd (Expr));
-
-                        Type_Table : constant array (1 .. 4) of Entity_Id
-                          := (Empty,
-                              Standard_Wide_Wide_String,
-                              Standard_Wide_String,
-                              Standard_String);
+                        L_Type : constant Entity_Id :=
+                          Preferred_String_Type (Left_Opnd (Expr));
+                        R_Type : constant Entity_Id :=
+                          Preferred_String_Type (Right_Opnd (Expr));
+
+                        Type_Table : constant array (1 .. 4) of Entity_Id :=
+                          (Empty,
+                           Standard_Wide_Wide_String,
+                           Standard_Wide_String,
+                           Standard_String);
                      begin
                         for Idx in Type_Table'Range loop
                            if L_Type = Type_Table (Idx) or
diff --git a/gcc/ada/sem_util.adb b/gcc/ada/sem_util.adb
index 688d9232b44..b423f87d969 100644
--- a/gcc/ada/sem_util.adb
+++ b/gcc/ada/sem_util.adb
@@ -9805,8 +9805,8 @@ package body Sem_Util is
                      end if;
                   end;
                else
-                  UI_Discrim_Value
-                    := Expr_Value (Type_Low_Bound (Discrim_Value_Subtype));
+                  UI_Discrim_Value :=
+                    Expr_Value (Type_Low_Bound (Discrim_Value_Subtype));
                end if;
          end case;
 
@@ -9860,14 +9860,14 @@ package body Sem_Util is
       if Present (Variant) then
          if Discrim_Value_Status = Static_Subtype then
             declare
-               Discrim_Value_Subtype_Intervals
-                 : constant Interval_Lists.Discrete_Interval_List
-                 := Interval_Lists.Type_Intervals (Discrim_Value_Subtype);
-
-               Variant_Intervals
-                 : constant Interval_Lists.Discrete_Interval_List
-                 := Interval_Lists.Choice_List_Intervals
-                     (Discrete_Choices => Discrete_Choices (Variant));
+               Discrim_Value_Subtype_Intervals :
+                 constant Interval_Lists.Discrete_Interval_List :=
+                 Interval_Lists.Type_Intervals (Discrim_Value_Subtype);
+
+               Variant_Intervals :
+                 constant Interval_Lists.Discrete_Interval_List :=
+                 Interval_Lists.Choice_List_Intervals
+                   (Discrete_Choices => Discrete_Choices (Variant));
             begin
                if not Interval_Lists.Is_Subset
                         (Subset => Discrim_Value_Subtype_Intervals,
@@ -11616,8 +11616,8 @@ package body Sem_Util is
             declare
                Constit_Elmt : Elmt_Id;
                Constit_Id   : Entity_Id;
-               Constits     : constant Elist_Id
-                 := Part_Of_Constituents (Item_Id);
+               Constits     : constant Elist_Id :=
+                 Part_Of_Constituents (Item_Id);
             begin
                if Present (Constits) then
                   Constit_Elmt := First_Elmt (Constits);
@@ -18620,8 +18620,8 @@ package body Sem_Util is
    function Is_Null_Extension_Of
      (Descendant, Ancestor : Entity_Id) return Boolean
    is
-      Ancestor_Type : constant Entity_Id
-        := Underlying_Type (Base_Type (Ancestor));
+      Ancestor_Type : constant Entity_Id :=
+        Underlying_Type (Base_Type (Ancestor));
       Descendant_Type : Entity_Id := Underlying_Type (Base_Type (Descendant));
    begin
       pragma Assert (not Is_Class_Wide_Type (Descendant));
@@ -29899,8 +29899,8 @@ package body Sem_Util is
          Comp := First (Component_Associations (N));
          while Present (Comp) loop
             declare
-               Choice_Intervals : constant Discrete_Interval_List
-                 := Choice_List_Intervals (Choices (Comp));
+               Choice_Intervals : constant Discrete_Interval_List :=
+                 Choice_List_Intervals (Choices (Comp));
             begin
                for J in Choice_Intervals'Range loop
                   Num_I := Num_I + 1;
@@ -29914,8 +29914,8 @@ package body Sem_Util is
          --  Normalize the lists sorting and merging the intervals
 
          declare
-            Aggr_Intervals : Discrete_Interval_List (1 .. Num_I)
-                               := Intervals (1 .. Num_I);
+            Aggr_Intervals : Discrete_Interval_List (1 .. Num_I) :=
+              Intervals (1 .. Num_I);
          begin
             Normalize_Interval_List (Aggr_Intervals, Num_I);
             Check_Consistency (Aggr_Intervals (1 .. Num_I));
@@ -29993,8 +29993,8 @@ package body Sem_Util is
          while Present (Choice) loop
             if Nkind (Choice) = N_Others_Choice then
                declare
-                  Others_Choice : Node_Id
-                    := First (Others_Discrete_Choices (Choice));
+                  Others_Choice : Node_Id :=
+                    First (Others_Discrete_Choices (Choice));
                begin
                   while Present (Others_Choice) loop
                      Count := Count + 1;
@@ -30029,8 +30029,8 @@ package body Sem_Util is
 
             when N_Subtype_Indication =>
                declare
-                  Range_Exp : constant Node_Id
-                    := Range_Expression (Constraint (Choice));
+                  Range_Exp : constant Node_Id :=
+                    Range_Expression (Constraint (Choice));
                begin
                   return (Low  => Expr_Value (Low_Bound (Range_Exp)),
                           High => Expr_Value (High_Bound (Range_Exp)));
@@ -30177,8 +30177,8 @@ package body Sem_Util is
             Not_Null : Pos range List'Range;
             --  Index of the most recently examined non-null interval
 
-            Null_Interval : constant Discrete_Interval
-              := (Low => Uint_1, High => Uint_0); -- any null range ok here
+            Null_Interval : constant Discrete_Interval :=
+              (Low => Uint_1, High => Uint_0); -- any null range ok here
          begin
             if List'Length = 0 or else Is_Null (List'First) then
                Null_Interval_Count := List'Length;
@@ -30972,9 +30972,9 @@ package body Sem_Util is
             -------------------------------------------
 
             procedure Declare_Indirect_Temp_Via_Allocation is
-               Access_Type_Id : constant Entity_Id
-                 := Make_Temporary
-                      (Loc, Indirect_Temp_Access_Type_Char, Attr_Prefix);
+               Access_Type_Id : constant Entity_Id :=
+                 Make_Temporary
+                   (Loc, Indirect_Temp_Access_Type_Char, Attr_Prefix);
 
                Temp_Decl : constant Node_Id :=
                  Make_Object_Declaration (Loc,
@@ -31020,14 +31020,14 @@ package body Sem_Util is
                   return New_Occurrence_Of (Typ, Loc);
                end Designated_Subtype_Mark;
 
-               Access_Type_Def : constant Node_Id
-                 := Make_Access_To_Object_Definition
-                      (Loc, Subtype_Indication => Designated_Subtype_Mark);
+               Access_Type_Def : constant Node_Id :=
+                 Make_Access_To_Object_Definition
+                   (Loc, Subtype_Indication => Designated_Subtype_Mark);
 
-               Access_Type_Decl : constant Node_Id
-                 := Make_Full_Type_Declaration
-                      (Loc, Access_Type_Id,
-                       Type_Definition => Access_Type_Def);
+               Access_Type_Decl : constant Node_Id :=
+                 Make_Full_Type_Declaration
+                   (Loc, Access_Type_Id,
+                    Type_Definition => Access_Type_Def);
             begin
                Mutate_Ekind (Temp_Id, E_Variable);
                Set_Etype (Temp_Id, Access_Type_Id);